Transfer a call

A code snippet that shows how to transfer control of the current call to control by a new NCCO.

Example

Replace the following variables in the example code:

KeyDescription
VOICE_CALL_ID

The UUID of the call leg.

VOICE_NCCO_URL

The URL of the NCCO to execute. URLs must be array type.

Prerequisites

Execute the following command at your terminal prompt to create the JWT for authentication:

export JWT=$(nexmo jwt:generate $PATH_TO_PRIVATE_KEY application_id=$NEXMO_APPLICATION_ID)

Write the code

Add the following to transfer-a-call.sh:

curl -X PUT https://api.nexmo.com/v1/calls/$VOICE_CALL_ID \
  -H "Authorization: Bearer $JWT" \
  -H "Content-Type: application/json"\
  -d '{"action": "transfer",
      "destination": {"type": "ncco", "url": ["'"$VOICE_NCCO_URL"'"]}}'

View full source

Run your code

Save this file to your machine and run it:

bash transfer-a-call.sh

Prerequisites

npm install @vonage/server-sdk

Create a file named transfer-a-call.js and add the following code:

const { Vonage } = require('@vonage/server-sdk');

const vonage = new Vonage({
  applicationId: VONAGE_APPLICATION_ID,
  privateKey: VONAGE_PRIVATE_KEY,
});

View full source

Write the code

Add the following to transfer-a-call.js:

vonage.voice.transferCallWithURL(VOICE_CALL_ID, VOICE_NCCO_URL)
  .then(() => console.log(`Call transfered to ${VOICE_NCCO_URL}`))
  .catch((error) => console.error(error));

View full source

Run your code

Save this file to your machine and run it:

node transfer-a-call.js

Prerequisites

Add the following to build.gradle:

implementation 'com.vonage:server-sdk-kotlin:2.1.1'

Create a file named TransferCall and add the following code to the main method:

val client = Vonage {
    applicationId(VONAGE_APPLICATION_ID)
    privateKeyPath(VONAGE_PRIVATE_KEY_PATH)
}

View full source

Write the code

Add the following to the main method of the TransferCall file:

client.voice.call(VOICE_CALL_ID).transfer(VOICE_NCCO_URL)

View full source

Run your code

We can use the application plugin for Gradle to simplify the running of our application. Update your build.gradle with the following:

apply plugin: 'application'
mainClassName = project.hasProperty('main') ? project.getProperty('main') : ''

Run the following gradle command to execute your application, replacing com.vonage.quickstart.kt.voice with the package containing TransferCall:

gradle run -Pmain=com.vonage.quickstart.kt.voice.TransferCall

Prerequisites

Add the following to build.gradle:

implementation 'com.vonage:server-sdk:9.3.1'

Create a file named TransferCall and add the following code to the main method:

VonageClient client = VonageClient.builder()
        .applicationId(VONAGE_APPLICATION_ID)
        .privateKeyPath(VONAGE_PRIVATE_KEY_PATH)
        .build();

View full source

Write the code

Add the following to the main method of the TransferCall file:

client.getVoiceClient().transferCall(VOICE_CALL_ID, VOICE_NCCO_URL);

View full source

Run your code

We can use the application plugin for Gradle to simplify the running of our application. Update your build.gradle with the following:

apply plugin: 'application'
mainClassName = project.hasProperty('main') ? project.getProperty('main') : ''

Run the following gradle command to execute your application, replacing com.vonage.quickstart.voice with the package containing TransferCall:

gradle run -Pmain=com.vonage.quickstart.voice.TransferCall

Prerequisites

Install-Package Vonage

Write the code

Add the following to TransferCall.cs:

var credentials = Credentials.FromAppIdAndPrivateKeyPath(VONAGE_APPLICATION_ID, VONAGE_PRIVATE_KEY_PATH);
var client = new VonageClient(credentials);

var callEditCommand = new CallEditCommand()
{
    Action = CallEditCommand.ActionType.transfer,
    Destination = new Destination()
    {
        Url = new[] { VOICE_NCCO_URL }
    }
};

var response = await client.VoiceClient.UpdateCallAsync(VOICE_CALL_ID, callEditCommand);

View full source

Prerequisites

composer require vonage/client

Write the code

Add the following to index.php:

require_once __DIR__ . '/../../vendor/autoload.php';

$keypair = new \Vonage\Client\Credentials\Keypair(file_get_contents(VONAGE_APPLICATION_PRIVATE_KEY_PATH), VONAGE_APPLICATION_ID);
$client = new \Vonage\Client($keypair);

$call = $client->voice()->get(UUID);
$client->voice()->transferCall(
    $call->getUuid(),
    new \Vonage\Voice\NCCO\Action\Transfer("https://raw.githubusercontent.com/nexmo-community/ncco-examples/gh-pages/transfer.json")
);

View full source

Run your code

Save this file to your machine and run it:

php index.php

Prerequisites

pip install vonage python-dotenv

Write the code

Add the following to transfer-a-call.py:

from vonage import Auth, Vonage

client = Vonage(
    Auth(
        application_id=VONAGE_APPLICATION_ID,
        private_key=VONAGE_PRIVATE_KEY,
    )
)

client.voice.transfer_call_answer_url(VOICE_CALL_ID, VOICE_NCCO_URL)

View full source

Run your code

Save this file to your machine and run it:

python voice/transfer-a-call.py

Prerequisites

gem install vonage

Write the code

Add the following to transfer-a-call.rb:

client = Vonage::Client.new(
  application_id: VONAGE_APPLICATION_ID,
  private_key: VONAGE_PRIVATE_KEY
)

ncco = {"type": "ncco", "url": [VOICE_NCCO_URL]}

response = client.voice.transfer(VOICE_CALL_ID, destination: ncco)

View full source

Run your code

Save this file to your machine and run it:

ruby transfer-a-call.rb

Try it out

You will need to:

  1. Set up a call and obtain the call UUID. You could use the 'connect an inbound call' code snippet to do this.
  2. Run the example code to transfer the call.
  3. Control will be transferred to a new NCCO, and you will hear a text-to-speech message to confirm this.

Further Reading

  • Conference Calling - This guide explains the two concepts Vonage associates with a call, a leg and a conversation.